// Worldmap
//
// 10.08.2002 / Horst Klier  (www.klier.net)
//
// Erzeugt Landkarten als BMP aus den BlueMarble-Daten der NASA
//
// ACHTUNG: Bentigt eine neuere tdbengine als 6.2.7
// Diese ist derzeit noch nicht offiziell verfgbar,
// sollte es aber in Krze sein.
//
// BlueMarble:
// http://earthobservatory.nasa.gov/Newsroom/BlueMarble/
// FTP: ftp://gloria2-f.gsfc.nasa.gov/pub/stockli/
//
// Laden Sie vom FTP Server die Daten in der
// Auflsung 21600x21600 und entpacken Sie diese.
// Passen Sie den Pfad unten an.
//
// Der Beispielausschnitt gibt Europa stark
// verkleinert aus.
//

// Ausschnitt, der ausgegeben wird
var nWidth  : Integer := 256          // Breite der Ausgabe-Bitmap (muss durch 4 teilbar sein)
var nHeight : Integer := 200          // Hhe der Ausgabe-Bitmap
var nXStart : Integer := 20000        // X-Koordinate von dem Punkt, an dem die Ausgabe beginnt
var nYStart : Integer := 2890         // Y-Koordinate von dem Punkt, an dem die Ausgabe beginnt
var nXStep : Integer := 20            // X-Wert: Abstand der Pixel in der Ursprungsdatei, die fr die Ausgabe verwendet werden
var nYStep : Integer := 20            // Y-Wert: Abstand der Pixel in der Ursprungsdatei, die fr die Ausgabe verwendet werden
var fInterpolieren : Integer := 0     // Wenn 1 werden die Pixel bei X und Y Step nicht bersprungen sondern zu Einem zusammengerechnet
var cOutputFile : String := 'map.bmp' // Namen der Ausgabedatei
// Hinweise:
// nXStep und nYStep=1 erzeugt die Ausgabedatei in der maximalen Eingangsauflsung
//


// Orginal-Dateien
var cInputFile1 : String := '\bluemarble\e_3x21600x21600.raw'  // Entspricht nicht dem Orginaldateinamen
var cInputFile2 : String := '\bluemarble\w_3x21600x21600.raw'
var org_height : Integer := 21600
var org_width  : Integer := 21600

Procedure Long(n:REAL):STRING
	VARDEF c : STRING
	VARDEF n1,n2,n3,n4 : REAL
	?n#0/n1:=INT(n/(256*256*256))
	n:=n - (n1*256*256*256)
	?n#0/n2:=INT(n/(256*256))
	n:=n - (n2*256*256)
	?n#0/n3:=INT(n/(256))
	n:=n - (n3*256)
	?n#0/n4:=INT(n)
	n:=n - (n4)
	c:=CHR(n4)+CHR(n3)+CHR(n2)+CHR(n1)
	RETURN c
Endproc

Procedure Word(n:REAL):STRING
	VARDEF c : STRING
	VARDEF n1,n2 : REAL
	?n#0/n1:=INT(n/(256))
	n:=n - (n1*256)
	?n#0/n2:=INT(n)
	n:=n - (n2)
	c:=CHR(n2)+CHR(n1)
	RETURN c
Endproc

Procedure Color(b,g,r,f:REAL):STRING
	.. f = Fllbytes
	VARDEF c : STRING
	c:=CHR(r)+CHR(g)+CHR(b)+nTimes(CHR(0),f)
	Return c
Endproc


procedure XYPos(x,y:Integer):Integer
  if x>org_width*2
    x:=0
  end
  if y>org_height
    y:=0
  end
  if x>org_width
    x:=x-org_width
  end
  return (x*3)+((org_width*org_height*3)-(y*org_width*3))
endproc

procedure fhInput(xNow,fh1,fh2:Integer):Integer
  if xNow>=org_width
    Return fh1
  else
    Return fh2
  end
endproc

Procedure WriteBMP
    nYStart := org_height-(nYStart+(nHeight*nYStep))

    var fh1,fh2 : Integer
	Var x,y : Integer
    var buffer : byte[]
    initarray(buffer[3])
    fh1:=f_open(cInputFile1)
    if fh1<=0
      CgiWriteLn('Fehler beim Oeffnen von "'+cInputFile1+'"')
      HALT
    end
    fh2:=f_open(cInputFile2)
    if fh2<=0
      CgiWriteLn('Fehler beim Oeffnen von "'+cInputFile2+'"')
      HALT
    end


	DEF Colors=0
	VARDEF nFH,i,nBits : Integer
	VARDEF nLen,nWid,nHig : Integer
	nHig:=nHeight
	nWid:=nWidth
	nBits:=nWidth
	WHILE Int(nWid/4)#(nWid/4)
	  nWid++
	END
	nLen:=(nWid*nHig)+30+(4*Colors)+24
  CGIWriteLn("Schreibe Header")
	nFH:=ReWrite(cOutputFile)
	Write(nFH,"BM")							.. Kennung BMP
	Write(nFH,Long(nLen))					.. Lnge BMP-Datei
	Write(nFH,Word(0))						.. X-Offset
	Write(nFH,Word(0))						.. Y-Offset
	Write(nFH,Long(54+Colors*4))		.. Offset zur Bitmap
	Write(nFH,Word(40))						.. Offset zur Farbtabelle
	Write(nFH,Word(0)+Word(nBits))	.. Breite
	Write(nFH,Word(0)+Word(nHig))	.. Hhe
	Write(nFH,Word(0))						.. ???
	Write(nFH,Word(1))						.. Anzahl Bit-Planes
	Write(nFH,Word(24))						.. Bit pro Plane
	Write(nFH,nTimes(CHR(0),16))		.. Fllbytes
	Write(nFH,CHR(Colors))				.. Anzahl Farben
	Write(nFH,nTimes(CHR(0),7))		.. Fllbytes
  CGIWriteLn("Schreibe Farben")

  CGIWriteLn("Schreibe Daten")
  y:=0
  While y<=nHeight-1
    cgiwrite(str(y)+'/'+str(nHeight)+'')
    x:=0
    while x<=nWidth-1
      cgiwrite('.')
      var xNow,yNow : Integer
      xNow:=nXStart+(x*nXStep)
      yNow:=nYStart+(y*nYStep)
      if fInterpolieren=0
        f_seek(fhInput(xNow,fh1,fh2),XYPos(xNow,yNow))
        f_read(fhInput(xNow,fh1,fh2),buffer,3)
        Write(nFH,chr(buffer[2])+chr(buffer[1])+chr(buffer[0]))
      else
        var r,g,b,ix,iy : Integer
        r:=0
        g:=0
        b:=0
        iy:=0
        while iy<nYStep
          ix:=0
          while ix<nXStep
            f_seek(fhInput(xNow+ix,fh1,fh2),XYPos(xNow+ix,yNow+iy))
            f_read(fhInput(xNow+ix,fh1,fh2),buffer,3)
            r:=r+buffer[0]
            g:=g+buffer[1]
            b:=b+buffer[2]
            ix++
          end
          iy++
        end
        r:=r div (nYStep*nXStep)
        g:=g div (nYStep*nXStep)
        b:=b div (nYStep*nXStep)
        Write(nFH,chr(b)+chr(g)+chr(r))
      end
      x++
    end
    cgiwriteln('')
    y++
  End
	Close(nFH)
	f_close(fh2)
	f_close(fh1)
EndProc


Procedure Main
  CGICloseBuffer
  WriteBMP
EndProc
